/* bin2h.c: Simple binary to c const definition converter  */
/*
** Copyright (C) 2002 Martin Glunz <mg-home@gmx.de>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include <stdio.h>
#include <string.h>

int makecfile(char *infile, char *outfile)
{
  FILE *in, *out;
  char symnam[80];
  long insize;
  unsigned char data;
  int i;
  strcpy(symnam,outfile);
  strtok(symnam,".");
  in=fopen(infile,"rb");
  if (in==NULL) return 1;
  out=fopen(outfile,"w");
  if (out==NULL) {
    fclose(in); return 2;
  };
  fseek(in,0,SEEK_END); insize=ftell(in); rewind(in);
  fprintf(out,"const unsigned char %s[%ld] = {\n",symnam,insize);
  for (i=0; i<insize; i++) {
    fread(&data,1,1,in);
    fprintf(out,"0x%02X",data);
    if (i==insize-1) fprintf(out,"};\n"); else fprintf(out,",\n");
  };
  fclose(in); fclose(out);
  return 0;
}

int main(int argc, char *argv[])
{
  char infile[80], outfile[80];
  int i;
  argc--;
  if (argc<1) return 99;
  //printf("bin2h converter\n");
  strcpy(infile,argv[1]);
  if (!strchr(infile,'.')) strcat(infile,".bin");
  if (argc>1) {
    strcpy(outfile,argv[2]);
    if (!strchr(outfile,'.')) strcat(outfile,".h");
  } else {
    strcpy(outfile,infile);
    strcat(outfile,".h");
  };
  //printf("Converting %s to %s ...\n",infile,outfile);
  if ((i=makecfile(infile,outfile))!=0) printf("bin2c: failed to convert %s, code %d\n",infile,i);
  return i;
}
