OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("_start")
MEMORY
{
	bpgm(rwx) : o = 0xfef10, l = 0x2f0
	ram(rwx) : o = 0xff300, l = 0xc00
	rsv(rwx) : o = 0xfff00, l = 0x100
	/* The top of main RAM, which the stack starts. */
	topram(rw) : o = 0xffdfc, l = 0x4
	/* At the very top of the address space is the 8-bit area. */
	eight : o = 0xffff00, l = 0x10
}
SECTIONS 				
{ 					
.text : {
	*(.text) 				
	*(.strings)
	*(.rodata) 				
   	 _etext = . ; 
	} > ram
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > ram
.data : {
	___data = . ;
	*(.data)
	*(.tiny)
	 _edata = .;
	} > ram
.bss : {
	 _bss_start = . ;
	*(.bss)
	*(COMMON)
	 _end = . ;  
	}  >ram
.stack : {
	 _stack = . ; 
	*(.stack)
	}  > topram
.stab 0 (NOLOAD) : {
	[ .stab ]
	}
.stabstr 0 (NOLOAD) : {
	[ .stabstr ]
	}
}
