/* mkchks.c: Simple ROM checksum generator  */
/*
** Copyright (C) 2002 Martin Glunz <mg-home@gmx.de>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/signal.h>
#include <sys/wait.h>
#include <termios.h>
#include <time.h>

#define ROMSIZE 0xff00

unsigned short romimg[ROMSIZE];

int main(int argc, char **argv)
{
  FILE *fp;
  int i,j;
  unsigned short k,l;
  if (argc>1) {
    fp=fopen(argv[1],"rb");
    if (fp==0) {perror(argv[1]); return 1;};
  } else return 1;
  memset(romimg, 0xff, sizeof(romimg));
  i=fread(romimg, 2, ROMSIZE, fp);
  fclose(fp);
  printf("%d\n",i);
  k=0;
  for (j=0; j<ROMSIZE; j++) {l=romimg[j]; l=(l<<8) | (l>>8); k+=l; };
  printf("%04X\n", k);
  if (k!=0) {
    l=0xffff-k;
    l=(l<<8) | (l>>8);
    romimg[i]=l;
    k=0;
    for (j=0; j<ROMSIZE; j++) {l=romimg[j]; l=(l<<8) | (l>>8); k+=l; };
    printf("%04X\n", k);
    if (argc>1) {
      fp=fopen(argv[1],"wb");
      if (fp==0) {perror(argv[1]); return 1;};
    } else return 1;
    j=fwrite(romimg, 2, i+1, fp);
    fclose(fp);
    if (j!=i+1) return 1;
  };
  return 0;
}
