/*

  H83048F.H
       
*/

/* DMA channels */

#define DMAC_MAR0AR     (* (volatile unsigned char *) ( 0xffff20 ))
#define DMAC_MAR0AE     (* (volatile unsigned char *) ( 0xffff21 ))
#define DMAC_MAR0AH     (* (volatile unsigned char *) ( 0xffff22 ))
#define DMAC_MAR0AL     (* (volatile unsigned char *) ( 0xffff23 ))
#define DMAC_ETCR0AH    (* (volatile unsigned char *) ( 0xffff24 ))
#define DMAC_ETCR0AL    (* (volatile unsigned char *) ( 0xffff25 ))
#define DMAC_IOAR0A     (* (volatile unsigned char *) ( 0xffff26 ))
#define DMAC_DTCR0A     (* (volatile unsigned char *) ( 0xffff27 ))
#define DMAC_MAR0AW     (* (volatile unsigned short *)( 0xffff22 ))
#define DMAC_MAR0A      (* (volatile unsigned long *) ( 0xffff20 ))

#define DMAC_MAR0BR     (* (volatile unsigned char *)         ( 0xffff28 ))
#define DMAC_MAR0BE     (* (volatile unsigned char *)         ( 0xffff29 ))
#define DMAC_MAR0BH     (* (volatile unsigned char *)         ( 0xffff2A ))
#define DMAC_MAR0BL     (* (volatile unsigned char *)         ( 0xffff2B ))
#define DMAC_ETCR0BH    (* (volatile unsigned char *)         ( 0xffff2C ))
#define DMAC_ETCR0BL    (* (volatile unsigned char *)         ( 0xffff2D ))
#define DMAC_IOAR0B     (* (volatile unsigned char *)         ( 0xffff2E ))
#define DMAC_DTCR0B     (* (volatile unsigned char *)         ( 0xffff2F ))
#define DMAC_MAR0BW     (* (volatile unsigned short *)        ( 0xffff2A ))
#define DMAC_MAR0B      (* (volatile unsigned long *)         ( 0xffff28 ))

#define DMAC_MAR1AR     (* (volatile unsigned char *)         ( 0xffff30 ))
#define DMAC_MAR1AE     (* (volatile unsigned char *)         ( 0xffff31 ))
#define DMAC_MAR1AH     (* (volatile unsigned char *)         ( 0xffff32 ))
#define DMAC_MAR1AL     (* (volatile unsigned char *)         ( 0xffff33 ))
#define DMAC_ETCR1AH    (* (volatile unsigned char *)         ( 0xffff34 ))
#define DMAC_ETCR1AL    (* (volatile unsigned char *)         ( 0xffff35 ))
#define DMAC_IOAR1A     (* (volatile unsigned char *)         ( 0xffff36 ))
#define DMAC_DTCR1A     (* (volatile unsigned char *)         ( 0xffff37 ))
#define DMAC_MAR1AW     (* (volatile unsigned short *)        ( 0xffff32 ))
#define DMAC_MAR1A      (* (volatile unsigned long *)         ( 0xffff30 ))

#define DMAC_MAR1BR     (* (volatile unsigned char *)         ( 0xffff38 ))
#define DMAC_MAR1BE     (* (volatile unsigned char *)         ( 0xffff39 ))
#define DMAC_MAR1BH     (* (volatile unsigned char *)         ( 0xffff3A ))
#define DMAC_MAR1BL     (* (volatile unsigned char *)         ( 0xffff3B ))
#define DMAC_ETCR1BH    (* (volatile unsigned char *)         ( 0xffff3C ))
#define DMAC_ETCR1BL    (* (volatile unsigned char *)         ( 0xffff3D ))
#define DMAC_IOAR1B     (* (volatile unsigned char *)         ( 0xffff3E ))
#define DMAC_DTCR1B     (* (volatile unsigned char *)         ( 0xffff3F ))
#define DMAC_MAR1BW     (* (volatile unsigned short *)        ( 0xffff3A ))
#define DMAC_MAR1B      (* (volatile unsigned long *)         ( 0xffff38 ))


/* ITU - 5 channels*/

#define ITU_TSTR        (* (volatile unsigned char *)         ( 0xffff60 ))
#define ITU_TSNC        (* (volatile unsigned char *)         ( 0xffff61 ))
#define ITU_TMDR        (* (volatile unsigned char *)         ( 0xffff62 ))
#define ITU_TFCR        (* (volatile unsigned char *)         ( 0xffff63 ))
#define ITU_TOER        (* (volatile unsigned char *)         ( 0xffff90 ))
#define ITU_TOCR        (* (volatile unsigned char *)         ( 0xffff91 ))

#define ITU_TCR0        (* (volatile unsigned char *)         ( 0xffff64 ))
#define ITU_TIOR0       (* (volatile unsigned char *)         ( 0xffff65 ))
#define ITU_TIER0       (* (volatile unsigned char *)         ( 0xffff66 ))
#define ITU_TSR0        (* (volatile unsigned char *)         ( 0xffff67 ))
#define ITU_TCNT0       (* (volatile unsigned short *)        ( 0xffff68 ))
#define ITU_GRA0        (* (volatile unsigned short *)        ( 0xffff6A ))
#define ITU_GRB0        (* (volatile unsigned short *)        ( 0xffff6C ))

#define ITU_TCR1        (* (volatile unsigned char *)         ( 0xffff6e ))
#define ITU_TIOR1       (* (volatile unsigned char *)         ( 0xffff6f ))
#define ITU_TIER1       (* (volatile unsigned char *)         ( 0xffff70 ))
#define ITU_TSR1        (* (volatile unsigned char *)         ( 0xffff71 ))
#define ITU_TCNT1       (* (volatile unsigned short *)        ( 0xffff72 ))
#define ITU_GRA1        (* (volatile unsigned short *)        ( 0xffff74 ))
#define ITU_GRB1        (* (volatile unsigned short *)        ( 0xffff76 ))

#define ITU_TCR2        (* (volatile unsigned char *)         ( 0xffff78 ))
#define ITU_TIOR2       (* (volatile unsigned char *)         ( 0xffff79 ))
#define ITU_TIER2       (* (volatile unsigned char *)         ( 0xffff7a ))
#define ITU_TSR2        (* (volatile unsigned char *)         ( 0xffff7b ))
#define ITU_TCNT2       (* (volatile unsigned short *)        ( 0xffff7c ))
#define ITU_GRA2        (* (volatile unsigned short *)        ( 0xffff7e ))
#define ITU_GRB2        (* (volatile unsigned short *)        ( 0xffff80 ))

#define ITU_TCR3        (* (volatile unsigned char *)         ( 0xffff82 ))
#define ITU_TIOR3       (* (volatile unsigned char *)         ( 0xffff83 ))
#define ITU_TIER3       (* (volatile unsigned char *)         ( 0xffff84 ))
#define ITU_TSR3        (* (volatile unsigned char *)         ( 0xffff85 ))
#define ITU_TCNT3       (* (volatile unsigned short *)        ( 0xffff86 ))
#define ITU_GRA3        (* (volatile unsigned short *)        ( 0xffff88 ))
#define ITU_GRB3        (* (volatile unsigned short *)        ( 0xffff8a ))
#define ITU_BRA3        (* (volatile unsigned short *)        ( 0xffff8c ))
#define ITU_BRB3        (* (volatile unsigned short *)        ( 0xffff8e ))

#define ITU_TCR4        (* (volatile unsigned char *)         ( 0xffff92 ))
#define ITU_TIOR4       (* (volatile unsigned char *)         ( 0xffff93 ))
#define ITU_TIER4       (* (volatile unsigned char *)         ( 0xffff94 ))
#define ITU_TSR4        (* (volatile unsigned char *)         ( 0xffff95 ))
#define ITU_TCNT4       (* (volatile unsigned short *)        ( 0xffff96 ))
#define ITU_GRA4        (* (volatile unsigned short *)        ( 0xffff98 ))
#define ITU_GRB4        (* (volatile unsigned short *)        ( 0xffff9a ))
#define ITU_BRA4        (* (volatile unsigned short *)        ( 0xffff9c ))
#define ITU_BRB4        (* (volatile unsigned short *)        ( 0xffff9e ))


/* TPC */

#define TPC_TPMR        (* (volatile unsigned char *)         ( 0xffffa0 ))
#define TPC_TPCR        (* (volatile unsigned char *)         ( 0xffffa1 ))
#define TPC_NDERB       (* (volatile unsigned char *)         ( 0xffffa2 ))
#define TPC_NDERA       (* (volatile unsigned char *)         ( 0xffffa3 ))
#define TPC_NDRB1       (* (volatile unsigned char *)         ( 0xffffa4 ))
#define TPC_NDRA1       (* (volatile unsigned char *)         ( 0xffffa5 ))
#define TPC_NDRB2       (* (volatile unsigned char *)         ( 0xffffa6 ))
#define TPC_NDRA2       (* (volatile unsigned char *)         ( 0xffffa7 ))


/* WDT */

#define WDT_TCSR        (* (volatile unsigned char *)         ( 0xffffa8 ))
#define WDT_TCNT        (* (volatile unsigned char *)         ( 0xffffa9 ))
#define WDT_RSTCSR      (* (volatile unsigned char *)         ( 0xffffab ))

#define WDT_WTCSR       (* (volatile unsigned short *)        ( 0xffffa8 ))
#define WDT_WTCNT       (* (volatile unsigned short *)        ( 0xffffa8 ))
#define WDT_WRSTCSR     (* (volatile unsigned short *)        ( 0xffffaa ))
#define WDT_WRSTOE      (* (volatile unsigned short *)        ( 0xffffaa ))


/*  REFRESH CTRLR */

#define RFSHCR          (* (volatile unsigned char *)         ( 0xffffac ))
#define RTMCSR          (* (volatile unsigned char *)         ( 0xffffad ))
#define RTCNT           (* (volatile unsigned char *)         ( 0xffffae ))
#define RTCOR           (* (volatile unsigned char *)         ( 0xffffaf ))


/* Serial Comms, channels 0 & 1*/

#define SCI0_SMR        (* (volatile unsigned char *)         ( 0xffffb0 ))
#define SCI0_BRR        (* (volatile unsigned char *)         ( 0xffffb1 ))
#define SCI0_SCR        (* (volatile unsigned char *)         ( 0xffffb2 ))
#define SCI0_TDR        (* (volatile unsigned char *)         ( 0xffffb3 ))
#define SCI0_SSR        (* (volatile unsigned char *)         ( 0xffffb4 ))
#define SCI0_RDR        (* (volatile unsigned char *)         ( 0xffffb5 ))
#define SCI0_SCMR       (* (volatile unsigned char *)         ( 0xffffb6 ))

#define SCI1_SMR        (* (volatile unsigned char *)         ( 0xffffb8 ))
#define SCI1_BRR        (* (volatile unsigned char *)         ( 0xffffb9 ))
#define SCI1_SCR        (* (volatile unsigned char *)         ( 0xffffba ))
#define SCI1_TDR        (* (volatile unsigned char *)         ( 0xffffbb ))
#define SCI1_SSR        (* (volatile unsigned char *)         ( 0xffffbc ))
#define SCI1_RDR        (* (volatile unsigned char *)         ( 0xffffbd ))


/* IO ports */

#define P1DR            (* (volatile unsigned char *)         ( 0xffffc2 ))
#define P1DDR           (* (volatile unsigned char *)         ( 0xffffc0 ))

#define P2CR            (* (volatile unsigned char *)         ( 0xffffd8 ))
#define P2DR            (* (volatile unsigned char *)         ( 0xffffc3 ))
#define P2DDR           (* (volatile unsigned char *)         ( 0xffffc1 ))

#define P3DR            (* (volatile unsigned char *)         ( 0xffffc6 ))
#define P3DDR           (* (volatile unsigned char *)         ( 0xffffc4 ))

#define P4CR            (* (volatile unsigned char *)         ( 0xffffda ))
#define P4DR            (* (volatile unsigned char *)         ( 0xffffc7 ))
#define P4DDR           (* (volatile unsigned char *)         ( 0xffffc5 ))

#define P5CR            (* (volatile unsigned char *)         ( 0xffffdb ))
#define P5DR            (* (volatile unsigned char *)         ( 0xffffca ))
#define P5DDR           (* (volatile unsigned char *)         ( 0xffffc8 ))

#define P6DR            (* (volatile unsigned char *)         ( 0xffffcb ))
#define P6DDR           (* (volatile unsigned char *)         ( 0xffffc9 ))

#define P7DR            (* (volatile unsigned char *)         ( 0xffffce ))

#define P8DR            (* (volatile unsigned char *)         ( 0xffffcf ))
#define P8DDR           (* (volatile unsigned char *)         ( 0xffffcd ))

#define P9DR            (* (volatile unsigned char *)         ( 0xffffd2 ))
#define P9DDR           (* (volatile unsigned char *)         ( 0xffffd0 ))

#define PADR            (* (volatile unsigned char *)         ( 0xffffd3 ))
#define PADDR           (* (volatile unsigned char *)         ( 0xffffd1 ))

#define PBDR            (* (volatile unsigned char *)         ( 0xffffd6 ))
#define PBDDR           (* (volatile unsigned char *)         ( 0xffffd4 ))


/* D/A CONVERTER */

#define DADR0           (* (volatile unsigned char *)         ( 0xffffdc ))
#define DADR1           (* (volatile unsigned char *)         ( 0xffffdd ))
#define DACR            (* (volatile unsigned char *)         ( 0xffffde ))


/* A/D Converter */

#define ADDRA           (* (volatile unsigned short *)        ( 0xffffe0 ))
#define ADDRAH          (* (volatile unsigned char *)         ( 0xffffe0 ))
#define ADDRAL          (* (volatile unsigned char *)         ( 0xffffe1 ))
#define ADDRB           (* (volatile unsigned short *)        ( 0xffffe2 ))
#define ADDRBH          (* (volatile unsigned char *)         ( 0xffffe2 ))
#define ADDRBL          (* (volatile unsigned char *)         ( 0xffffe3 ))
#define ADDRC           (* (volatile unsigned short *)        ( 0xffffe4 ))
#define ADDRCH          (* (volatile unsigned char *)         ( 0xffffe4 ))
#define ADDRCL          (* (volatile unsigned char *)         ( 0xffffe5 ))
#define ADDRD           (* (volatile unsigned short *)        ( 0xffffe6 ))
#define ADDRDH          (* (volatile unsigned char *)         ( 0xffffe6 ))
#define ADDRDL          (* (volatile unsigned char *)         ( 0xffffe7 ))
#define ADCSR           (* (volatile unsigned char *)         ( 0xffffe8 ))
#define ADCR            (* (volatile unsigned char *)         ( 0xffffe9 ))


/* BUS CTRLR */

#define ABWCR           (* (volatile unsigned char *)         ( 0xffffec ))
#define ASTCR           (* (volatile unsigned char *)         ( 0xffffed ))
#define WCR             (* (volatile unsigned char *)         ( 0xffffee ))
#define WCER            (* (volatile unsigned char *)         ( 0xffffef ))
#define BRCR            (* (volatile unsigned char *)         ( 0xfffff3 ))


/* SYSTEM CTRL */

#define DASTCR          (* (volatile unsigned char *)         ( 0xffff5c ))
#define DIVCR           (* (volatile unsigned char *)         ( 0xffff5d ))
#define MSTCR           (* (volatile unsigned char *)         ( 0xffff5e ))
#define CSCR            (* (volatile unsigned char *)         ( 0xffff5f ))
#define MDCR            (* (volatile unsigned char *)         ( 0xfffff1 ))
#define SYSCR           (* (volatile unsigned char *)         ( 0xfffff2 ))


/* INTERRUPT CTRLR */

#define ISCR            (* (volatile unsigned char *)         ( 0xfffff4 ))
#define IER             (* (volatile unsigned char *)         ( 0xfffff5 ))
#define ISR             (* (volatile unsigned char *)         ( 0xfffff6 ))
#define IPRA            (* (volatile unsigned char *)         ( 0xfffff8 ))
#define IPRB            (* (volatile unsigned char *)         ( 0xfffff9 ))

/* FLASH CONTROL */
#define FLMCR           (* (volatile unsigned char *)         ( 0xffff40 ))
#define EBR             (* (volatile unsigned short *)        ( 0xffff42 ))
#define EBR1            (* (volatile unsigned char *)         ( 0xffff42 ))
#define EBR2            (* (volatile unsigned char *)         ( 0xffff43 ))
#define RAMCR           (* (volatile unsigned char *)         ( 0xffff48 ))

