/* pdhw.h: H8 register definitions for ramloader sample hardware  */
/*
** Copyright (C) 2002 Martin Glunz <mg-home@gmx.de>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/



#ifndef __pdhw__
#define __pdhw__


// Pins Port A
#define SRSTB	0x80
#define CS4	0x40
#define CS5	0x20
#define LED0	0x10
#define	SRCLK	0x08
#define	LED1	0x04
#define	REL1	0x02
#define REL0	0x01

#define CS6	0x10
#define SRDI0	0x04
#define SROE	0x02
#define DBG0	0x01

// Pins Port B
#define DIGIN0	0x01
#define DIGIN1	0x02
#define DIGIN2	0x04
#define DIGIN3	0x08
#define DIGIN4	0x10
#define DIGIN5	0x20
#define DIGIN6	0x40
#define DIGIN7	0x80

// Pins Port 9
#define TXD0	0x01
#define TXD1	0x02
#define RXD0	0x04
#define RXD1	0x08
#define RTS1_0	0x10
#define	CTS1_0	0x20

#define	LONSRV	0x10
#define LONRST	0x20

// Pins Port 8
#define VPPOFF	0x01
#define	CS3	0x02
#define	CS2	0x04
#define	CS1	0x08
#define	STDP	0x10

// Pins Port 7
#define	AIN0	0x01
#define AIN1	0x02
#define AIN2	0x04
#define AIN3	0x08
#define AIN4	0x10
#define	AIN5	0x20
#define	DA0	0x40
#define	DA1	0x80

#define	DSR1	0x08
#define	DCD1	0x10
#define	CTS1	0x20

// Pins Port 6
#define DE	0x01
#define	SDA	0x02
#define	SCL	0x04
#define	AS	0x08
#define	RD	0x10
#define	HWR	0x20
#define	LWR	0x40

#define P6DIR	DE;

// Pins Port 5
#define A16	0x01
#define A17	0x02
#define A18	0x04
#define SRDO	0x08

// Pins Port 4
#define DIGIN8	0x01
#define DIGIN9	0x02
#define DIGIN10	0x04
#define DIGIN11	0x08
#define DIGIN12	0x10
#define DIGIN13	0x20
#define DIGIN14	0x40
#define DIGIN15	0x80

// Timer
#define CLKDIV1       0x00
#define CLKDIV2       0x01
#define CLKDIV4       0x02
#define CLKDIV8       0x03
#define STR0          0x01
#define STR1          0x02
#define STR2          0x04
#define STR3          0x08
#define STR4          0x10
#define PWM0	      0x01
#define PWM1	      0x02
#define PWM2	      0x04
#define PWM3	      0x08
#define PWM4          0x10
#define IMIEA	      0x01
#define IMIEB	      0x02
#define IMFA          0x01
#define IMFB          0x02

#define TPSC0         0x01
#define TPSC1         0x02
#define TPSC2         0x04
#define CKEG0         0x08
#define CKEG1         0x10
#define CCLR0         0x20
#define CCLR1         0x40

#define LED0_S	      0x04
#define LED1_S	      0x08
#define REL0_S	      0x01
#define REL1_S	      0x02
#define DTR_S	      0x10

#define RAM_START	(char *)0x20000
#define	RAM_END		(char *)0xa0000
extern void free_ram_start;
extern unsigned char hwrev;

// CLOCK
#define CLK_BASE 0xA0000
#define CLK_SEC1 *(volatile char *)(CLK_BASE + 0)
#define CLK_SEC10 *(volatile char *)(CLK_BASE + 1)
#define CLK_MIN1 *(volatile char *)(CLK_BASE + 2)
#define CLK_MIN10 *(volatile char *)(CLK_BASE + 3)
#define CLK_HRS1 *(volatile char *)(CLK_BASE + 4)
#define CLK_HRS10 *(volatile char *)(CLK_BASE + 5)
#define CLK_DAY1 *(volatile char *)(CLK_BASE + 6)
#define CLK_DAY10 *(volatile char *)(CLK_BASE + 7)
#define CLK_MON1 *(volatile char *)(CLK_BASE + 8)
#define CLK_MON10 *(volatile char *)(CLK_BASE + 9)
#define CLK_YR1 *(volatile char *)(CLK_BASE + 10)
#define CLK_YR10 *(volatile char *)(CLK_BASE + 11)
#define CLK_DOW *(volatile char *)(CLK_BASE + 12)
#define CLK_CRD *(volatile char *)(CLK_BASE + 13)
#define CLK_CRE *(volatile char *)(CLK_BASE + 14)
#define CLK_CRF *(volatile char *)(CLK_BASE + 15)

// Lon
#define LON_BASE 0xC0000
#define LON_DATA *(volatile unsigned char *)(LON_BASE +0)
#define LON_RDY *(volatile unsigned char *)(LON_BASE +1)

#define LPIO_RST 1
#define LPIO_SYN 2
#define LPIO_PTK 3
#define LPIO_GTK 4
#define LPIO_TST 5


//ADC
#define ADST_SET      0x20
#define ADST_CLEAR    0xdf
#define ADF_CLEAR     0x7f
#define EIRQ_AD       0x40
#define AD_CLK_FAST   0x08
#define AD_ADIE	0x40
#define AD_ADST 0x20

#define RDRF 0x40
// Receive data register full
#define RIE 0x40
// Receive Interrupt  Enable
#define TDRE 0x80
// Transmit data register empty
#define PER  0x08
// Parity Error
#define FER  0x10
// Frame Error
#define ORER 0x20
// Overrun Error
// Transmit Enable
#define TIE 0x80  
// All_send (Transmit End)
#define TEND 0x04

                          
#define  SCR_RE 0x10
#define  TEIE   0x04               


#endif // __pdhw__
